struct noArvoreSegmentosIndireto {
  int * s;
  int tam_s;
  Intervalo t;
  noArvoreSegmentosIndireto * esq;
  noArvoreSegmentosIndireto * dir;
};

class ArvoreSegmentosIndireto{
	
 private:
   static int BuscaBinaria (int * s, Segmento * vetorGlobal, int inicio, int fim, Ponto p){
  	int tam = fim - inicio;
  	if (tam == 1){
  	  /*verifique se o segmento do meio eh vertical.*/
  	  if (vetorGlobal[s[inicio]].segmento_vertical()){
  	    if (vetorGlobal[s[inicio]].get_pe().getY() <= p.getY() /*&& p.getY() <= vetorGlobal[s.at(inicio)].get_pd().getY()*/) 
  	      return inicio;
  	    else return -1;
  	  }
  	  else if (!Left(vetorGlobal[s[inicio]].get_pe(), vetorGlobal[s[inicio]].get_pd(), p))
  	  	  return inicio;
  	  else{
  	  	/*Segmento::ImprimeSegmento(s.at(inicio));
  	  	printf("->");
  	  	Ponto::ImprimePonto(p);
  	  	printf("\n");*/
  	  	return -1;
  	  }
  	}
  	int meio = inicio - 1 + (int)((tam / 2.0) + 0.5);
  	/*verifique se o segmento do meio eh vertical.*/
  	if (vetorGlobal[s[meio]].segmento_vertical()){
  	  if (p.getY() >= vetorGlobal[s[meio]].get_pd().getY())
  	    return ArvoreSegmentosIndireto::BuscaBinaria (s, vetorGlobal, meio + 1, fim, p);
  	  else /*if (p.getY() > vetorGlobal[s.at(meio)].get_pd().getY())*/
  	    return ArvoreSegmentosIndireto::BuscaBinaria (s, vetorGlobal, inicio, meio + 1, p);
  	  /*else return meio;*/
  	}
  	else{
  	  if (!Left(vetorGlobal[s[meio]].get_pe(), vetorGlobal[s[meio]].get_pd(), p))
  		return ArvoreSegmentosIndireto::BuscaBinaria (s, vetorGlobal, inicio, meio + 1, p);
  	  else
  		return ArvoreSegmentosIndireto::BuscaBinaria (s, vetorGlobal, meio + 1, fim, p);
  	}
  }
  
 public:
  
  /*************************************************************
    Recebe: Uma arvore T nao vazia e um segmento.
    Devolve: Uma lista l com os segmentos que atravessam x(seg).
  **************************************************************/
  static void ConsultaArvoreSegmentosIndireto (noArvoreSegmentosIndireto * T, Segmento * vetorGlobal, Segmento seg, list<int> & l){
    noArvoreSegmentosIndireto * u = T;
    int i, n;
    n = u->tam_s;
    if (n > 0){
        /*n = u->tam_s;*/
	    i = ArvoreSegmentosIndireto::BuscaBinaria(u->s, vetorGlobal, 0, n, seg.get_pe());
	    if (i != -1){
	      while (i < n && LeftOn(vetorGlobal[u->s[i]].get_pe(), vetorGlobal[u->s[i]].get_pd(), seg.get_pd())){
	      	/*se u->s->at(i) é vertical.*/
	      	if (!(vetorGlobal[u->s[i]].segmento_vertical()))
	    	  l.push_back(u->s[i]);
	    	else if (seg.intercepta(vetorGlobal[u->s[i]]))
	    	  l.push_back(u->s[i]);
	    	i++;
	      }
	    }
    }
    if (u->esq != NULL){
      if (Intervalo::Pertence(seg.get_pe().getX(), u->esq->t))
	    ConsultaArvoreSegmentosIndireto (u->esq, vetorGlobal, seg, l);
      else
	    ConsultaArvoreSegmentosIndireto (u->dir, vetorGlobal, seg, l);
    }  
  }
  
  /*************************************************************************
   Recebe: Um vetor de intervalos (v) ordenados pelo ponto extremo esquerdo.
   Devolve: Uma árvore de segmentos.
  **************************************************************************/
  static noArvoreSegmentosIndireto * ConstroiArvoreSegmentos2DIndireto(Intervalo* I, int n_i, Segmento * vetorGlobal, int * S, 
                                                                       int n, char * s){
    
    noArvoreSegmentosIndireto * T;
    T = ArvoreSegmentosIndireto::ConstroiHeap(I, n_i);
    ArvoreSegmentosIndireto::InsereSegmentos(T, vetorGlobal, S, n);
    if (strcmp(s, "simetrico") != 0)
      ArvoreSegmentosIndireto::OrdenaBarras(T);
    else
      ArvoreSegmentosIndireto::OrdenaBarrasSimetrico(T);
    
    return T;
    
  }
  
  static void OrdenaBarras (noArvoreSegmentosIndireto * T){
  	noArvoreSegmentosIndireto * u = T;
  	if (u != NULL){
	  if (u->tam_s > 1)
	    sort(u->s, u->s + u->tam_s, menor_barra_indireto);
	  ArvoreSegmentosIndireto::OrdenaBarras(u->esq);
	  ArvoreSegmentosIndireto::OrdenaBarras(u->dir);
  	}
  }
  
  static void OrdenaBarrasSimetrico (noArvoreSegmentosIndireto * T){
    noArvoreSegmentosIndireto * u = T;
  	if (u != NULL){
	  if (u->s != NULL){
	  	sort(u->s, u->s + u->tam_s, menor_barra_indireto_simetrico);
	  }
	  ArvoreSegmentosIndireto::OrdenaBarrasSimetrico(u->esq);
	  ArvoreSegmentosIndireto::OrdenaBarrasSimetrico(u->dir);
  	}
  }
  
  /****************************************************************
   Recebe: Um vetor de intervalos (v).
   Devolve: Um heap T com os elementos de v nele inseridos.
  ****************************************************************/
  static noArvoreSegmentosIndireto * ConstroiHeap (Intervalo * v, int n){
    int h, exp, x, y, m, i, j;
    
    h = 0;
    exp = 1;
    while (exp < n){
      h++;
      exp *= 2;
    }
    
    x = exp - n;
    y = n - x;
    
    m = 2*n-1;

    noArvoreSegmentosIndireto * T;
    T = (noArvoreSegmentosIndireto *) malloc (sizeof(noArvoreSegmentosIndireto) * m);
    if (T == NULL){
      printf("Erro na alocação de memória para uma árvore limite associada\n.");
      exit(0);
    }

    i = m-1;
    
    /*Construção das folhas do último nível*/
    for (j = y-1; j >= 0; j--){
      T[i].t.set_pe(v[j].get_pe(), v[j].get_pe_aberto());
      T[i].t.set_pd(v[j].get_pd(), v[j].get_pd_aberto());
      T[i].esq = NULL;
      T[i].dir = NULL;
      T[i].s = NULL;
      T[i].tam_s = 0;
      i--;
    }
      
    /*Construção das folhas do penúltimo nível*/
    for (j = n-1; j >= y; j--){
      T[i].t.set_pe(v[j].get_pe(), v[j].get_pe_aberto());
      T[i].t.set_pd(v[j].get_pd(), v[j].get_pd_aberto());
      T[i].esq = NULL;
      T[i].dir = NULL;
      T[i].s = NULL;
      T[i].tam_s = 0;
      i--;
    }
        
    /*Construção dos nós internos*/
    /*Ainda tenho que provar que, pela construção, todo nó interno tem um filho à esquerda e à direita*/
    int e, d;//filhos à esquerda (com íncide igual à e) e à direita (com índice igual à d) de arvore[i].
    //for (int j = 0; j < numNosInternos; j++){
    while (i >= 0){
      e = i*2+1;
      d = i*2+2;
      T[i].t.set_pe(T[e].t.get_pe(), T[e].t.get_pe_aberto());
      T[i].t.set_pd(T[d].t.get_pd(), T[d].t.get_pd_aberto());
      /*T[i].t = Intervalo(T[e].t.get_pe(), T[d].t.get_pd(), T[e].t.get_pe_aberto(), T[d].t.get_pd_aberto());*/
      T[i].s = NULL;
      T[i].esq = &(T[e]);
      T[i].dir = &(T[d]);
      T[i].tam_s = 0;
      i--;
    }

    return T;

  }
  
  /*******************************************************
  Recebe: Uma arvore binaria balanceada T e um segmento v.
  Devolve: T com v inserido.
  *******************************************************/
  static void Insere (noArvoreSegmentosIndireto * T, Segmento * vetorGlobal, int n, int s){
    noArvoreSegmentosIndireto * u = T;
      if (vetorGlobal[s].get_pe().getX() <= u->t.get_pe() && 
	      vetorGlobal[s].get_pd().getX() >= u->t.get_pd()){
	      	
	 	 u->tam_s++;
	  	 u->s = (int *) realloc (u->s, sizeof(int) * u->tam_s);/*isso pode alterar o consumo de tempo do algoritmo de construcao.*/	  	 
	     u->s[u->tam_s-1] = s;  
      }
      else{
	    if (Intervalo::Pertence(vetorGlobal[s].get_pe().getX(), u->esq->t) || Intervalo::Pertence(vetorGlobal[s].get_pd().getX(), u->esq->t) ||
	       (vetorGlobal[s].get_pe().getX() <= u->esq->t.get_pe() && vetorGlobal[s].get_pd().getX() >= u->esq->t.get_pd())){
	      Insere(u->esq, vetorGlobal, n, s);
	    }
	    if (Intervalo::Pertence(vetorGlobal[s].get_pd().getX(), u->dir->t) || Intervalo::Pertence(vetorGlobal[s].get_pe().getX(), u->dir->t) ||
	    (vetorGlobal[s].get_pe().getX() <= u->dir->t.get_pe() && vetorGlobal[s].get_pd().getX() >= u->dir->t.get_pd())){
	      Insere(u->dir, vetorGlobal, n, s);
	    }
      }
  }  
  
  
  /***********************************************************
  Recebe: Uma arvore binaria balanceada e um vetor de segmentos 
          (nao precisa estar ordenado).
  Devolve: Uma arvore de segmentos em T.
  ************************************************************/
  static void InsereSegmentos (noArvoreSegmentosIndireto * T, Segmento * vetorGlobal, int * S, int n){
    for (int i = 0; i < n; i++){
      ArvoreSegmentosIndireto::Insere(T, vetorGlobal, n, S[i]);
    }
  }
  
    static void ImprimeArvoreSegmentos (noArvoreSegmentosIndireto * T, Segmento * vetorGlobal){
    noArvoreSegmentosIndireto * u;
    u = T;
    if (u != NULL){
      printf("Intervalo: ");
      Intervalo::ImprimeIntervalo(u->t);
      printf("Segmentos: ");
      
      int i, n = u->tam_s;
      for (i = 0; i < n; i++){
        printf("[ ");
        Ponto::ImprimePonto(vetorGlobal[u->s[i]].get_pe()); 
        printf(" : ");
        Ponto::ImprimePonto(vetorGlobal[u->s[i]].get_pd());
        printf(" ]");
      }
      printf("\n");
      
      ArvoreSegmentosIndireto::ImprimeArvoreSegmentos(u->esq, vetorGlobal);
      ArvoreSegmentosIndireto::ImprimeArvoreSegmentos(u->dir, vetorGlobal);
    }
  }
  
  static void inicializa (noArvoreSegmentosIndireto * T, int n){
    noArvoreSegmentosIndireto * v = T;
    int i;
    if (v != NULL){
      for (i = 0; i < n; i++)
        if (v[i].s != NULL)
          free(v[i].s);	
      free(v);
    }
  }
  
  static size_t consumo_espaco (noArvoreSegmentosIndireto * T){
    noArvoreSegmentosIndireto * v = T;
    size_t c = 0;
    if (v != NULL){
      c = sizeof(v) + sizeof(v->t) + sizeof(int)*v->tam_s + sizeof(v->tam_s);
      c += ArvoreSegmentosIndireto::consumo_espaco(v->esq);
      c += ArvoreSegmentosIndireto::consumo_espaco(v->dir);
    }
    return c;
  }
 
};
