struct noArvoreLimiteAFCIndireto{
  int p;
  bool isFim;
  noArvoreLimiteAFCIndireto * esq;
  noArvoreLimiteAFCIndireto * dir;
};

struct noArvoreLimiteFCIndireto{
  int p;
  noArvoreLimiteFCIndireto * esq;
  noArvoreLimiteFCIndireto * dir;
  noArvoreLimiteAFCIndireto * T_assoc;
  int tam_assoc;
};

class ArvoreLimite_fcIndireto {    
 private:

static void criaPonteiros (Segmento * vetorGlobal, noArvoreLimiteAFCIndireto * v_v, int tam, noArvoreLimiteAFCIndireto * v_v_e, int tam_e, noArvoreLimiteAFCIndireto * v_v_d, int tam_d, char * p){
    
    int j_ve = 0, j_vd = 0;
    for (int i = 0; i < tam; i++){
      if (j_ve < tam_e)
	    v_v[i].esq = &(v_v_e[j_ve]);
      else
	    v_v[i].esq = NULL;
      if (j_vd < tam_d)
	    v_v[i].dir = &(v_v_d[j_vd]);
      else 
	    v_v[i].dir = NULL;
      if (j_ve < tam_e && vetorGlobal[v_v[i].p].qualPonto(p).Igual(vetorGlobal[v_v_e[j_ve].p].qualPonto(p)))
	    j_ve++;
      else
	    j_vd++;
    }
  }

 public:
  
  //vetOrdenadoX[0 .. tam-1] e vetOrdenadoY[0 .. tam-1].
  static noArvoreLimiteFCIndireto * ConstroiArvoreLimiteIndireto(Segmento * vetorGlobal, int * vetX, noArvoreLimiteAFCIndireto * vetY, int tam, char * p){
 
    noArvoreLimiteFCIndireto * v;
    v = (noArvoreLimiteFCIndireto *) malloc (sizeof(noArvoreLimiteFCIndireto));

    //----------------inicio- vector-----------------
    v->T_assoc = vetY;
    
    v->tam_assoc = tam;
    //-------------------fim-vector------------------

    /*Neste ponto encontramos a x-mediana de vet*/
    int i = (int)((tam/2.0)+0.5);
  
    /**************x-vetor - esquerda e direita************/
    
    int * novoVetOrdenadoXE = (int *) malloc (sizeof(int)*i);
    int * novoVetOrdenadoXD = (int *) malloc (sizeof(int)*(tam-i));
    
    int k;
   
    for (k = 0; k < i; k++)
      novoVetOrdenadoXE[k] = vetX[k];

    int indxd = 0;
    for (k = i; k < tam; k++){
      novoVetOrdenadoXD[indxd] = vetX[k];
      indxd++;
    }

    //----------inicio--------------
    noArvoreLimiteAFCIndireto * novoVetOrdenadoYE;
    novoVetOrdenadoYE = (noArvoreLimiteAFCIndireto *) malloc (sizeof(noArvoreLimiteAFCIndireto) * (i+1));
   
    novoVetOrdenadoYE[i].esq = NULL;
    novoVetOrdenadoYE[i].dir = NULL;
    novoVetOrdenadoYE[i].p = -1;
    novoVetOrdenadoYE[i].isFim = true;
    
    noArvoreLimiteAFCIndireto * novoVetOrdenadoYD;
    novoVetOrdenadoYD = (noArvoreLimiteAFCIndireto *) malloc (sizeof(noArvoreLimiteAFCIndireto) * (tam - i + 1));
        
    novoVetOrdenadoYD[tam - i].esq = NULL;
    novoVetOrdenadoYD[tam - i].dir = NULL;
    novoVetOrdenadoYD[tam - i].p = -1;
    novoVetOrdenadoYD[tam - i].isFim = true;
    
    
    //----------fim-----------------


    /**************y-vetor - esquerda e direita************/
    int ke = 0, kd = 0;

    for (int k = 0; k < tam; k++){
      if (vetorGlobal[vetY[k].p].qualPonto(p).xMenorIgual(vetorGlobal[vetX[i-1]].qualPonto(p))){
        novoVetOrdenadoYE[ke].p = vetY[k].p;
        novoVetOrdenadoYE[ke].esq = NULL;
        novoVetOrdenadoYE[ke].dir = NULL;
        novoVetOrdenadoYE[ke].isFim = false;
	    ke++;
      }
      else{
	    novoVetOrdenadoYD[kd].p = vetY[k].p;
	    novoVetOrdenadoYD[kd].esq = NULL;
	    novoVetOrdenadoYD[kd].dir = NULL;
	    novoVetOrdenadoYD[kd].isFim = false;
	    kd++;
      }
    }

    /***********************************/

    v->p = vetX[i-1];

    if (tam == 1){
      v->esq = NULL;
      v->dir = NULL;
      v->T_assoc[0].esq = NULL;
      v->T_assoc[0].dir = NULL;
      free(novoVetOrdenadoYE);
      free(novoVetOrdenadoYD);
    }
    else{
      /*****************criação dos ponteiros na estrutura associada******************/
      ArvoreLimite_fcIndireto::criaPonteiros(vetorGlobal, vetY, tam, novoVetOrdenadoYE, i, novoVetOrdenadoYD, tam-i, p);
      /*******************************************************************************/
      v->esq = ConstroiArvoreLimiteIndireto(vetorGlobal, novoVetOrdenadoXE, novoVetOrdenadoYE, i, p);
      v->dir = ConstroiArvoreLimiteIndireto(vetorGlobal, novoVetOrdenadoXD, novoVetOrdenadoYD, tam - i, p);
    }
     
    free(novoVetOrdenadoXE);
    free(novoVetOrdenadoXD);
    return v;
  }
  
  //limite do vetor v [inic ... fim - 1].
  //o parâmetro "Ponto p" é o ponto inferior esquerdo de W.
  static noArvoreLimiteAFCIndireto * EncontraNoDivideT_assoc (Segmento * vetorGlobal, noArvoreLimiteAFCIndireto *v, int inic, int fim, Ponto pt, char * p){
    int tam = fim - inic;
    if (tam == 1){
      if (pt.yMenorIgual(vetorGlobal[v[inic].p].qualPonto(p)))
	    return &(v[inic]);
      else
	    return NULL;//não existe tal ponto
    }
    int i = inic - 1 + ((int)((tam/2.0)+0.5));
    if(pt.yMaior(vetorGlobal[v[i].p].qualPonto(p)))
      return EncontraNoDivideT_assoc (vetorGlobal, v, i+1, fim, pt, p);
    else
      return EncontraNoDivideT_assoc (vetorGlobal, v, inic, i+1, pt, p);
  }
  
  //Recebe uma árvore limite, o ponto inferior esquerdo e superior direito de uma janela W.
  //Devolve um nó da árvore limite dentro de uma janela.
  static noArvoreLimiteFCIndireto * EncontraNoDivideX (Segmento * vetorGlobal, noArvoreLimiteFCIndireto *v, Ponto p_ie, Ponto p_sd, char * p){
    noArvoreLimiteFCIndireto  * ret = v;
    //enquanto ret não é uma folha e ret.p não está em um intervalo de W.
    //while (!(ArvoreLimite::isFolha(ret)) && (p_sd <= ret->p || p_ie > ret->p)){
    while (!(ArvoreLimite_fcIndireto::isFolha(ret)) && (p_sd.xMenorIgual(vetorGlobal[ret->p].qualPonto(p)) || p_ie.xMaior(vetorGlobal[ret->p].qualPonto(p)))){
      //if (p_sd <= ret->p)
      if (p_sd.xMenorIgual(vetorGlobal[ret->p].qualPonto(p)))
	    ret = (ret->esq);
      else
	    ret = (ret->dir);
    }
    return ret;
  }
  
  static void ConsultaArvoreLimiteIndireto(Segmento * vetorGlobal, noArvoreLimiteFCIndireto * v, Janela W, list <int> & l, char * p){
    noArvoreLimiteFCIndireto * v_div;
    v_div = ArvoreLimite_fcIndireto::EncontraNoDivideX(vetorGlobal, v, W.getPontoInferiorEsquerdo(), W.getPontoSuperiorDireito(), p);//W.getPontoInferiorEsquerdo(), W.getPontoSuperiorDireito());

    if (ArvoreLimite_fcIndireto::isFolha(v_div)){
      if (W.contem(vetorGlobal[v_div->p].qualPonto(p)))
	    l.push_back(v_div->p);
    }
    
    else {

      noArvoreLimiteAFCIndireto * vy_div;
      vy_div = EncontraNoDivideT_assoc(vetorGlobal, v_div->T_assoc, 0, v_div->tam_assoc, W.getPontoInferiorEsquerdo(), p);


      if (vy_div != NULL){ //se existir ponto no conjunto P(v_div) y-(maior ou igual) ao ponto p_ie
	    //anda para esquerda de v_div
	    noArvoreLimiteFCIndireto * v_aux = v_div->esq;
	    noArvoreLimiteAFCIndireto *  vy_aux = vy_div->esq;
	    while (!ArvoreLimite_fcIndireto::isFolha(v_aux) && vy_aux != NULL){
	      if (W.getPontoInferiorEsquerdo().xMenorIgual(vetorGlobal[v_aux->p].qualPonto(p))){
	        noArvoreLimiteAFCIndireto * vy_aux2 = vy_aux->dir;
	        while(vy_aux2 != NULL && !(vy_aux2->isFim) && vetorGlobal[vy_aux2->p].qualPonto(p).yMenorIgual(W.getPontoSuperiorDireito())){
		      l.push_back(vy_aux2->p);
		      vy_aux2++;
	        }
	        v_aux = v_aux->esq;
	        vy_aux = vy_aux->esq;
	      }
	      else{
	        v_aux = v_aux->dir;
	        vy_aux = vy_aux->dir;
	      }
	    }
	    
	  if (vy_aux != NULL && W.contem(vetorGlobal[v_aux->p].qualPonto(p))){//verifica se a folha está na janela.
	    l.push_back(v_aux->p);
	  }
	
	
	  //anda para a direita de v_div
	  v_aux = v_div->dir;
	  vy_aux = vy_div->dir;
	
	  while (!ArvoreLimite_fcIndireto::isFolha(v_aux) && vy_aux != NULL){
	    if (W.getPontoSuperiorDireito().xMaior(vetorGlobal[v_aux->p].qualPonto(p))){
	      noArvoreLimiteAFCIndireto * vy_aux2 = vy_aux->esq;
	      while(vy_aux2 != NULL && !(vy_aux2->isFim) && vetorGlobal[vy_aux2->p].qualPonto(p).yMenorIgual(W.getPontoSuperiorDireito())){
		    l.push_back(vy_aux2->p);
		    vy_aux2++;
	      }
	      v_aux = v_aux->dir;
	      vy_aux = vy_aux->dir;
	    }
	    else{
	      v_aux = v_aux->esq;
	      vy_aux = vy_aux->esq;
	    }
	  }
	  
	  if (vy_aux != NULL && W.contem(vetorGlobal[v_aux->p].qualPonto(p))){//verifica se a folha está na janela.
	    l.push_back(v_aux->p);
      }
    }
  }
}
  
static void inicializa (noArvoreLimiteFCIndireto * T){
  noArvoreLimiteFCIndireto * v = T;
  
  if (v != NULL){
  	ArvoreLimite_fcIndireto::inicializa(v->esq);
	ArvoreLimite_fcIndireto::inicializa(v->dir);
    ArvoreLimite_fcIndireto::inicializaAssociada (v->T_assoc);
	free(v);  
  }
}

static void inicializaAssociada (noArvoreLimiteAFCIndireto * T){
  noArvoreLimiteAFCIndireto * v = T;
  if (v != NULL){
    free(v);
  }
}

static size_t consumo_espaco (noArvoreLimiteFCIndireto *T){
  size_t c = 0;
  noArvoreLimiteFCIndireto * v = T;
  if (v != NULL){
    c = sizeof (v) + sizeof(v->p) + sizeof(v->tam_assoc);
    c += ArvoreLimite_fcIndireto::consumo_espaco_Associada(v->T_assoc);
    c += ArvoreLimite_fcIndireto::consumo_espaco (v->esq);
    c += ArvoreLimite_fcIndireto::consumo_espaco (v->dir);
  }
  return c;
}

static size_t consumo_espaco_Associada (noArvoreLimiteAFCIndireto *T){
  size_t c = 0;
  noArvoreLimiteAFCIndireto * v = T;
  if (v != NULL){
    c = sizeof(v) + sizeof(v->p) + sizeof(v->isFim);
    c += ArvoreLimite_fcIndireto::consumo_espaco_Associada (v->esq);
    c += ArvoreLimite_fcIndireto::consumo_espaco_Associada (v->dir);
  }
  return c;
}

static void ImprimeArvore(Segmento * vetorGlobal, noArvoreLimiteFCIndireto * T){
  noArvoreLimiteFCIndireto * v = T;
  if (v != NULL){
    Ponto::ImprimePonto(vetorGlobal[v->p].get_pe());
    printf("\n");
    printf("t_assoc = %d", v->tam_assoc);
    for (int i = 0; i < v->tam_assoc; i++){
      Ponto::ImprimePonto(vetorGlobal[v->T_assoc[i].p].get_pd());
      printf(" ");
    }
    printf("\n");
    ArvoreLimite_fcIndireto::ImprimeArvore(vetorGlobal, v->esq);
    ArvoreLimite_fcIndireto::ImprimeArvore(vetorGlobal, v->dir);
  } 
}

 template<class myType>
  static bool isFolha(myType * v){
    return (v->esq == NULL);
  }

};

