class Ponto{
 private:
  int x, y;
  
 public:
  Ponto (){
  }
  
  Ponto(int x, int y){
    this->x = x;
    this->y = y;
  }


   //Supomos que não existem pontos coincidentes, porém uma quina de uma janela pode coincidir com um ponto e assim, na comparação entre pontos de uma janela e pontos de um conjunto, é necessário verificar se eles são iguais.
  bool xMenorIgual(Ponto q){
    return (this->x < q.x || (this->x == q.x && this->y <= q.y));
  }

  bool xMenor(Ponto q){
    return (this->x < q.x || (this->x == q.x && this->y < q.y));
  }
  
  bool xMaior(Ponto q){
    return !(this->xMenorIgual(q));
  }

  bool yMenorIgual(Ponto q){
    return (this->y < q.y || (this->y == q.y && this->x <= q.x));
  }

  bool yMenor(Ponto q){
    return (this->y < q.y || (this->y == q.y && this->x < q.x));
  }

  bool yMaior(Ponto q){
    return !(this->yMenorIgual(q));
  }

  bool Igual (Ponto q){
    return (this->y == q.y && this->x == q.x);
  }

  static bool compareX (Ponto p, Ponto q){
    return (p.xMenorIgual(q));
  }

  static bool compareY (Ponto p, Ponto q){
    return (p.yMenorIgual(q));
  } 
  
  static void ImprimePonto(Ponto p){
    printf("(%d, %d)", p.getX(), p.getY());
  }

  int getX (){
    return this->x;
  }

  void setX (int x){
    this->x = x;
  }

  int getY (){
    return this->y;
  }

  void setY (int y){
    this->y = y;
  }

   /******************************************************
   Recebe: Um vetor nao vazio de pontos x-ordenados.
   Devolve: Um vetor de pontos x-ordenados sem repeticoes
            no eixo x.
  *******************************************************/
  /*static int TiraRepeticoesY (vector<Ponto> &P){
    int i, j;
    int n = P.size();
    i = 1; j = 1;
    while (i < n){
      if (P[i].getY() != P[i-1].getY()){
	P[j] = Ponto(P[i].getX(), P[i].getY());
	j++;
      }
      i++;
    }

    P.erase(P.begin()+j, P.end());
    return j;
  }*/

};

