/********************************************************************
 Recebe: Um triangulo formado pelos pontos a, b, c.
 Devolve: O valor da Area deste triangulo multiplicado por 2.
 *********************************************************************/
int Area2 (Ponto a, Ponto b, Ponto c){
  /*printf("%d\n", (a.getX() - c.getX()) * (b.getY() - c.getY()) - 
    (a.getY() - c.getY()) * (b.getX() - c.getX()));*/
  return (a.getX() - c.getX()) * (b.getY() - c.getY()) - 
    (a.getY() - c.getY()) * (b.getX() - c.getX());
}

/*********************************************************************
 Recebe: Um segemento de reta ab e um ponto c.
 Devolve: Verdadeiro se o ponto c esta a esquerda ou sobre o segmento 
 ab ou falso cc.
 **********************************************************************/
int LeftOn (Ponto a, Ponto b, Ponto c){
  return Area2(a, b, c) >= 0;
}

/*********************************************************************
 Recebe: Um segemento de reta ab e um ponto c.
 Devolve: Verdadeiro se o ponto c esta a esquerda do segmento ab ou 
 falso cc.
 **********************************************************************/
int Left (Ponto a, Ponto b, Ponto c){
  return Area2(a, b, c) > 0;
}

/*********************************************************************
 Recebe: Um segemento de reta ab e um ponto c.
 Devolve: Verdadeiro se o ponto c esta a em "cima" do segmento ab 
 ou falso cc.
 **********************************************************************/
int Collinear (Ponto a, Ponto b, Ponto c){
  return Area2(a, b, c) == 0;
}
